// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package task

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/workflow/workflow_models"
)

// PostTasksReader is a Reader for the PostTasks structure.
type PostTasksReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostTasksReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostTasksOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostTasksUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostTasksForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostTasksNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostTasksUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostTasksInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostTasksOK creates a PostTasksOK with default headers values
func NewPostTasksOK() *PostTasksOK {
	return &PostTasksOK{}
}

/* PostTasksOK describes a response with status code 200, with default header values.

Array of Email Messages
*/
type PostTasksOK struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.EmailMessagesResponse
}

func (o *PostTasksOK) Error() string {
	return fmt.Sprintf("[POST /tasks][%d] postTasksOK  %+v", 200, o.Payload)
}
func (o *PostTasksOK) GetPayload() *workflow_models.EmailMessagesResponse {
	return o.Payload
}

func (o *PostTasksOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.EmailMessagesResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTasksUnauthorized creates a PostTasksUnauthorized with default headers values
func NewPostTasksUnauthorized() *PostTasksUnauthorized {
	return &PostTasksUnauthorized{}
}

/* PostTasksUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostTasksUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *PostTasksUnauthorized) Error() string {
	return fmt.Sprintf("[POST /tasks][%d] postTasksUnauthorized  %+v", 401, o.Payload)
}
func (o *PostTasksUnauthorized) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostTasksUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTasksForbidden creates a PostTasksForbidden with default headers values
func NewPostTasksForbidden() *PostTasksForbidden {
	return &PostTasksForbidden{}
}

/* PostTasksForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostTasksForbidden struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *PostTasksForbidden) Error() string {
	return fmt.Sprintf("[POST /tasks][%d] postTasksForbidden  %+v", 403, o.Payload)
}
func (o *PostTasksForbidden) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostTasksForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTasksNotFound creates a PostTasksNotFound with default headers values
func NewPostTasksNotFound() *PostTasksNotFound {
	return &PostTasksNotFound{}
}

/* PostTasksNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostTasksNotFound struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *PostTasksNotFound) Error() string {
	return fmt.Sprintf("[POST /tasks][%d] postTasksNotFound  %+v", 404, o.Payload)
}
func (o *PostTasksNotFound) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostTasksNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTasksUnprocessableEntity creates a PostTasksUnprocessableEntity with default headers values
func NewPostTasksUnprocessableEntity() *PostTasksUnprocessableEntity {
	return &PostTasksUnprocessableEntity{}
}

/* PostTasksUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostTasksUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *PostTasksUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /tasks][%d] postTasksUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PostTasksUnprocessableEntity) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostTasksUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTasksInternalServerError creates a PostTasksInternalServerError with default headers values
func NewPostTasksInternalServerError() *PostTasksInternalServerError {
	return &PostTasksInternalServerError{}
}

/* PostTasksInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostTasksInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *PostTasksInternalServerError) Error() string {
	return fmt.Sprintf("[POST /tasks][%d] postTasksInternalServerError  %+v", 500, o.Payload)
}
func (o *PostTasksInternalServerError) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostTasksInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
